<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\DateUtil;

class FpaEstruteventoEntity
{
    public function __construct($entityManager, $hcmParameters){
        $this->hcmParameters = $hcmParameters;
        $this->entityManager = $entityManager;
    }
    
    public function retornaAssociacoesEstruturaEvento($nrOrg, $nrEstrutura){
        $resultado = $this->entityManager->getRepository(Repositories::FPA_ESTRUTEVENTO)->findBy(array('nrorg' => $nrOrg, 'nrestruturam' => $nrEstrutura));
        return $resultado;
    }

    public function determinaReferencia(){

        switch($this->getIdrefgerar()){
            case FpaVinceventoEntity::IDREFGERAR_PERCENTUAL:
                $referencia = $this->getVrpercent();
                break;

            case FpaVinceventoEntity::IDREFGERAR_MULTIPLICADOR:
                $referencia = $this->getVrmultiplic();
                break;

            case FpaVinceventoEntity::IDREFGERAR_DIVISOR:
                $referencia = $this->getVrdivide();
                break;

            case FpaVinceventoEntity::IDREFGERAR_NENHUM:
                $referencia = $this->getVrreffixo();
                break;
        }
        return $referencia;
    }

}

